# coding:utf8

__author__ = 'dong'

import os
import logging
import xml.dom.minidom
import re
import shutil
import glob
from xml.etree.ElementTree import ElementTree, Element
import distutils.dir_util
from xml.etree import ElementTree as ET
import gw_file_system

ANDROID_NS = 'http://schemas.android.com/apk/res/android'


def script_second(workspace_sdk_dir, extract_dir, channel_sdk_info, new_game_channel_info, game_info):
    logging.info('script_second: ' + str(channel_sdk_info))
    # 逆向渠道id
    public_xml = os.path.join(extract_dir, "res/values/public.xml")
    handle_public_xml(public_xml, "sobot_fileEndingAudio")
    handle_public_xml(public_xml, "sobot_fileEndingExcel")
    handle_public_xml(public_xml, "sobot_fileEndingImage")
    handle_public_xml(public_xml, "sobot_fileEndingPPT")
    handle_public_xml(public_xml, "sobot_fileEndingPackage")
    handle_public_xml(public_xml, "sobot_fileEndingPdf")
    handle_public_xml(public_xml, "sobot_fileEndingText")
    handle_public_xml(public_xml, "sobot_fileEndingVideo")
    handle_public_xml(public_xml, "sobot_fileEndingWord")

    return


def handle_public_xml(public_xml_path, remove_node):
    if not os.path.exists(public_xml_path):
        logging.info('public_xml is null: ' + public_xml_path)
        return
    new_lines = []
    with open(public_xml_path, 'r+') as f:
        for line in f.readlines():
            # l = line.strip()
            if line.find(remove_node) > -1:
                continue
            new_lines.append(line)
        f.seek(0)
        f.truncate()
        f.writelines(new_lines)
    return


def script(SDK, decompileDir, channelSdkInfo, new_game_channel_info, gameInfo):
    # s3 = decompileDir + "/smali_classes3"
    s1 = os.path.join(decompileDir, "smali", "com")
    smali_classes2_dir = create_mutil_smali(decompileDir)

    s3 = os.path.join(smali_classes2_dir, "com")
    list_package = ["yeepay", "utx", "tencent", "lilith", "lilithgame", "activeandroid", "qihoo", "android"]
    list_package.extend(["radical", "nostra13", "qiyukf", "dckj", "dc", "ansca"])
    if not os.path.exists(s3):
        distutils.dir_util.mkpath(s3)
    move_package(s1, s3, list_package)

    sdk_id = channelSdkInfo['id']
    if sdk_id == "323":
        modify_manifest(decompileDir, "requestLegacyExternalStorage")

    s1 = os.path.join(decompileDir, "smali", "androidx")
    if os.path.exists(s1):
        smali_classes2_dir = create_mutil_smali(decompileDir)
        s3 = os.path.join(smali_classes2_dir, "androidx")
        if not os.path.exists(s3):
            distutils.dir_util.mkpath(s3)
        move_package_one(s1, s3)

    logging.info("-----debug-----")


def script_last(SDK, decompileDir, channelSdkInfo, new_game_channel_info, gameInfo):
    logging.info('------------channelSdkInfo:' + str(channelSdkInfo))
    if channelSdkInfo['SDKName'] == 'reversefor360':
        replace_super_application(decompileDir)

    sdk_id = channelSdkInfo['id']
    if sdk_id == "234":
        s1 = os.path.join(decompileDir, "smali_classes4", "androidx")
        if os.path.exists(s1):
            smali_classes2_dir = create_mutil_smali(decompileDir)
            s3 = os.path.join(smali_classes2_dir, "androidx")
            list_package = ["fragment","interpolator","legacy","lifecycle","loader","localbroadcastmanager"]
            list_package.extend(["multidex","print","recyclerview","slidingpanelayout","swiperefreshlayout","vectordrawable","versionedparcelable","viewpager"])
            if not os.path.exists(s3):
                distutils.dir_util.mkpath(s3)
            move_package(s1, s3, list_package)


def create_mutil_smali(decompileDir):
    f_idx = 2
    while True:
        tmp = gw_file_system.get_full_path(os.path.join(decompileDir, 'smali_classes%d' % f_idx))
        tmp = tmp.replace('\\', '/')
        tmp = re.sub('/+', '/', tmp)
        if os.path.exists(tmp):
            f_idx += 1
        else:
            smali_classes2_dir = tmp
            break
    # endwhile
    os.mkdir(smali_classes2_dir)
    return smali_classes2_dir


def move_package(s1, s3, list_package):
    for d in list_package:
        src = os.path.join(s1, d)
        if os.path.exists(src):
            dst = os.path.join(s3, d)
            distutils.dir_util.copy_tree(src, dst)
            distutils.dir_util.remove_tree(src)


def move_package_one(src, dst):
    if os.path.exists(src):
        distutils.dir_util.copy_tree(src, dst)
        distutils.dir_util.remove_tree(src)


change_map = {".super Landroid/app/Application;": ".super Lcom/kf/framework/KFApplication;",
              "invoke-direct {p0}, Landroid/app/Application;-><init>()V": "invoke-direct {p0}, Lcom/kf/framework/KFApplication;-><init>()V",
              "invoke-super {p0, p1}, Landroid/app/Application;->attachBaseContext(Landroid/content/Context;)V": "invoke-super {p0, p1}, Lcom/kf/framework/KFApplication;->attachBaseContext(Landroid/content/Context;)V",
              "invoke-super {p0}, Landroid/app/Application;->onCreate()V": "invoke-super {p0}, Lcom/kf/framework/KFApplication;->onCreate()V", }


def replace_super_application(decompileDir):
    smali_files = glob.glob(
        os.path.join(decompileDir, 'smali*/com/radical/huangshangjixiang/qh360/CoronaApplication.smali'))
    if len(smali_files) == 1:
        game_application_file = smali_files[0];
        print game_application_file
        if os.path.isfile(game_application_file):
            with open(game_application_file, "r+") as f:
                file_str = f.read()
                for k, v in change_map.items():
                    file_str = file_str.replace(k, v)
            with open(game_application_file, "w+") as f:
                f.write(file_str)


def modify_manifest(decompileDir, removeKey):
    ET.register_namespace('android', ANDROID_NS)
    xmlparse = os.path.join(decompileDir, 'AndroidManifest.xml')
    root_node = ET.parse(xmlparse)
    root = root_node.getroot()
    name = '{' + ANDROID_NS + '}name'
    authorities = '{' + ANDROID_NS + '}' + removeKey
    package_name = root.attrib.get('package')
    if package_name == None:
        return
    providers = root.findall('./application')
    if providers != None:
        for provider in providers:
            # providerName = provider.attrib.get(name)
            # if 'com.netease.ntunisdk.CcMomentRecordingForegroundService' == providerName:
            # 使用try 主要是为了 防止此属性不在时，导致的错误，而程序终止
            try:
                del provider.attrib[authorities]
            except:
                ""

    root_node.write(xmlparse, 'utf-8')


if __name__ == '__main__':
    # replace_super_application("D:\work\wzdq")
    modify_manifest("E:\\apk\\youhua\\youhua.zip.out", "requestLegacyExternalStorage")
